unit uRDXTest;

{
   TRDX Objects - Demo application.

   Copyright (c) 1998  A-Couple-A-Nerds Computer Consulting & Jason Kaczor

   	               The demo application, and TRDX Objects system concept included in the "uRDX_Objects.pas"
	               file remain the copyright and intellectual property of Jason Kaczor of A-Couple-A-Nerds
	               Computer Consulting, all rights not specifically granted here are reserved until further
                       notice.

	               Jason Kaczor grants you the right to use, modify, and distribute this source
	               code, your modifications, as long as all files, and copyright notices in this
	               distribution are included, and a full copy is sent back to myself.

	               Jason Kaczor grants you the right to use the TRDX Objects system in your compiled,
	               commercial, freeware, or shareware applications.  When distributing TRDX Objects in
	               compiled form the files, and source code in this distribution need not be included.
	               The only caveat however, is if your compiled application is designed, and targetted
	               at developer's, software engineers, multimedia developers, or computer programmer's
	               you must include all files and copyright notices in this distribution.

                       These copyright notices may change at a future date, to be brought in line with
	               other projects, such as Project Jedi, or GNU.

   Created by:                   Jason Kaczor
                                 A Couple A Nerds Computer Consulting

                                 ACoupleANerds@compuserve.com
		                 kaczor@shaw.wave.ca
		                 Evenings: (403) 283-5351
		                 Daytime:  (403) 716-4466

   Last Change:                  04/23/1998

   Version:                      v.0.9

   Notes:                        v.0.9     You can do some preliminary tests using this form.
                                           It is not optimized.  Also note, that you will get mouse flicker,
                                           Intel is aware of this, and recomends hiding the mouse while it is
                                           within your application, and creating a sprite-based mouse pointer.

                                           Be aware, that you must create images/surfaces using the same
                                           color depth as your screen settings.  This is not a bug in the Intel RDX,
                                           but the lack of our implementing "Effects" objects.  Don't worry, it's coming.

   }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmRDXTest = class(TForm)
    timMouse: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure timMouseTimer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRDXTest: TfrmRDXTest;

implementation

uses
   uRdx_Objects;

var
   mySurf: TRDXSurface;
   myBack: TRDXBackground;
   myBackImage: TRDXImage;
   mySpriteImage: TRDXImage;
   mySprite: TRDXSprite;
   myEngine: TRDXManager;

   currX, currY: integer;

{$R *.DFM}

procedure TfrmRDXTest.FormCreate(Sender: TObject);
begin
     mySurf := TRDXSurface.Create('test', ClientWidth, ClientHeight, cl8bit);
     mySurf.WindowHandle := Handle;

     myBackImage := TRDXImage.Create('Background', 16, 16, cl8bit);
     myBackImage.FileName := 'test.bmp';
     myBackImage.SourcePosition := Point(0,0);
     myBackImage.SourceRect := Rect(0,0,16,16);
     myBackImage.LoadBitmap;

     mySpriteImage := TRDXImage.Create('Background', 16, 16, cl8bit);
     mySpriteImage.FileName := 'test2.bmp';
     mySpriteImage.SourcePosition := Point(0,0);
     mySpriteImage.SourceRect := Rect(0,0,8,8);
     mySpriteImage.LoadBitmap;

     myBack := TRDXBackground.Create('Background');
     myBack.HWBlit := true;
     myBack.ImageHandle := myBackImage.Handle;
     myBack.Destination := mySurf.Handle;

     mySprite := TRDXSprite.Create('mouse');
     mySprite.HWBlit := true;
     mySprite.ImageHandle := mySpriteImage.Handle;
     mySprite.Visible := true;
     mySprite.DrawOrder := 1;
     mySprite.Destination := mySurf.Handle;

     //myEngine := TRDXManager.Create;
     //myEngine.Priority := tpNormal;
     //myEngine.Resume;
end;

procedure TfrmRDXTest.FormDestroy(Sender: TObject);
begin
     //myEngine.Terminate;
     //myEngine.WaitFor;

     mySurf.Free;
end;

procedure TfrmRDXTest.FormClick(Sender: TObject);
begin
     mySurf.Draw;
end;

procedure TfrmRDXTest.timMouseTimer(Sender: TObject);
begin
     mySurf.Prepare;
     mySprite.Position := Point(currX, currY);
     mySurf.Draw;
end;

procedure TfrmRDXTest.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     currX := X;
     currY := Y;
end;

end.
